#ifndef JSONFUNCTIONSBNO_H
#define JSONFUNCTIONSBNO_H

#include "TM.h"
#include "TimeFunctions.h"
#include "json_functions.h"

static void loadjson(const jsonval& parent, const std::string& key, TimeJD& value, bool exist = true, bool* loaded = nullptr)
{
    const jsonval::ConstMemberIterator itr = parent.FindMember(key.c_str());

    if (itr == parent.MemberEnd() && exist) {
        throw Exp() << "error: element not found " << key;
    }
    else if (itr == parent.MemberEnd() && !exist) {
        if (loaded) {
            *loaded = false;
        }
        return;
    }

    const jsonval& a = itr->value;

    if (a.IsString()) {
        TimeGD gd;
        StrToDate(a.GetString(), gd);
        value = gd;
        if (loaded) {
            *loaded = true;
        }
    }
    else {
        throw (Exp() << "element '" << key << "'" << " has unexpected format '");
    }
}

static void loadjson(const jsonval& parent, const std::string& key, TimeGD& value, bool exist = true)
{
    const jsonval::ConstMemberIterator itr = parent.FindMember(key.c_str());

    if (itr == parent.MemberEnd() && exist) {
        throw Exp() << "error: element not found";
    }

    const jsonval& a = itr->value;

    if (a.IsString()) {
        StrToDate(a.GetString(), value);
    }
    else {
        throw (Exp() << "element '" << key << "'" << " has unexpected format '");
    }
}

static void PutValue(jsonalloc& alc, jsonval& ss, const std::string& conName, const TimeGD& value)
{
    jsonval jname(conName, alc);
    jsonval jvalue(DateToStr(value), alc);
    ss.AddMember(jname, jvalue, alc);
}

static void PutValue(jsonalloc& alc, jsonval& ss, const std::string& conName, const TimeJD& value)
{
    jsonval jname(conName, alc);
    jsonval jvalue(DateToStr(value), alc);
    ss.AddMember(jname, jvalue, alc);
}

#endif
